using ExampleWebApplication.Entities;
using NHibernate.Mapping.ByCode;
using NHibernate.Mapping.ByCode.Conformist;

namespace ExampleWebApplication.Infraestruture.NHibernate.EntityMappings
{
    public class SupplierMap : ClassMapping<Supplier>
    {
        public SupplierMap()
        {
            Table("Suppliers");
            Id(x => x.SupplierID, map => { map.Generator(Generators.Identity); map.Column("SupplierID"); });
            Property(x => x.CompanyName, map => { map.Column("CompanyName"); map.NotNullable(true); map.Length(40); });
            Property(x => x.ContactName, map => { map.Column("ContactName"); map.Length(30); });
            Property(x => x.ContactTitle, map => { map.Column("ContactTitle"); map.Length(30); });
            Property(x => x.Address, map => { map.Column("Address"); map.Length(60); });
            Property(x => x.City, map => { map.Column("City"); map.Length(15); });
            Property(x => x.Region, map => { map.Column("Region"); map.Length(15); });
            Property(x => x.PostalCode, map => { map.Column("PostalCode"); map.Length(10); });
            Property(x => x.Country, map => { map.Column("Country"); map.Length(15); });
            Property(x => x.Phone, map => { map.Column("Phone"); map.Length(24); });
            Property(x => x.Fax, map => { map.Column("Fax"); map.Length(24); });
            Property(x => x.HomePage, map => { map.Column("HomePage"); map.Length(1073741823); });
            //Bag(x => x.Products, map => { map.Inverse(true); map.Key(key => key.Column("SupplierID")); }, rel => rel.OneToMany()); ;
        }
    }
}
